diff --git a/src/main/java/net/minecraft/client/render/terrain/VertexAttribute.java b/src/main/java/net/minecraft/client/render/terrain/VertexAttribute.java
new file mode 100644
index 000000000..6ca70afde
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/VertexAttribute.java
@@ -0,0 +1,40 @@
+package net.minecraft.client.render.terrain;
+
+import java.nio.ByteBuffer;
+
+/**
+ * Can be used by mods
+ */
+public abstract class VertexAttribute {
+	
+	public final String name;
+	public final int id;
+	public final int type;
+	
+	public VertexAttribute(String name, int id, int type) {
+		this.name = name;
+		this.id = id;
+		this.type = type;
+	}
+	
+	public abstract void addVertex(ByteBuffer buffer);
+	
+	public abstract int getSize();
+	
+	public abstract int getTypeSize();
+	
+	public static int compare(VertexAttribute a1, VertexAttribute a2) {
+		if(a1 == a2) {
+			return 0;
+		}
+		
+		if(!a1.name.equals(a2.name)) return 1;
+		if(a1.id != a2.id) return 2;
+		if(a1.type != a2.type) return 3;
+		if(a1.getSize() != a2.getSize()) return 4;
+		
+		return 0;
+	}
+	
+
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java b/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
new file mode 100644
index 000000000..655877eb9
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
@@ -0,0 +1,206 @@
+package net.minecraft.client.render.terrain;
+
+import static org.lwjgl.opengl.GL15.*;
+
+import java.nio.ByteBuffer;
+import java.nio.ByteOrder;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.lwjgl.opengl.GL31;
+
+import net.minecraft.client.render.OpenGLHelper;
+
+/**
+ * 		A large buffer that contains vertex data
+ * <br> Elements can have different vertex configurations
+ * <br> When the buffer is full, it will automatically expand
+ */
+public class VertexBuffer {
+	
+	private int vbo;
+	private long capacity;
+	
+	public List<Entry> entries = new ArrayList<>();
+	
+	private int entryHashCounter;
+	
+	public VertexBuffer(long initialCapacity) {
+		this.capacity = initialCapacity;
+		
+		vbo = glGenBuffers();
+		glBindBuffer(GL_ARRAY_BUFFER, vbo);
+		glBufferData(GL_ARRAY_BUFFER, capacity, GL_STATIC_DRAW);
+		glBindBuffer(GL_ARRAY_BUFFER, 0);
+	}
+	
+	public Entry addVertexData(VertexData vertexData) {
+		if(vertexData.vertexCount <= 0) {
+			return null;
+		}
+		
+		// If the buffer is empty, just put it at the start
+		if(entries.size() == 0) {
+			return insertAtIndex(vertexData, 0);
+		}
+		
+		int bytes = vertexData.buffer.position();
+		
+		// If there is a single element in the buffer, check if there is enough space in front of it
+		// If not put it behind the other element
+		if(entries.size() == 1) {
+			Entry entry = entries.get(0);
+			if(entry.position > bytes) {
+				return insertAtIndex(vertexData, 0);
+			}else {
+				return insertAtIndex(vertexData, 1);
+			}
+		}
+		
+		// Check between every single element for a large enough gap
+		for(int i = 0; i < entries.size() - 1; i++) {
+			Entry entry = entries.get(i);
+			Entry nextEntry = entries.get(i + 1);
+			
+			int availableSpace = nextEntry.position - (entry.position + entry.size);
+			if(availableSpace > bytes) {
+				return insertAtIndex(vertexData, i + 1);
+			}
+		}
+		
+		// Put it all the way at the end
+		return insertAtIndex(vertexData, entries.size());
+	}
+	
+	private Entry insertAtIndex(VertexData vertexData, int listIndex) {
+		int pos = 0;
+		int bytes = vertexData.buffer.position();
+		
+		if(listIndex > 0) {
+			Entry prev = entries.get(listIndex - 1);
+			pos = prev.position + prev.size;
+		}
+		
+		if(pos + bytes >= capacity) {
+			expandVBO();
+		}
+		
+		Entry entry = new Entry(pos, bytes);
+		
+		if(listIndex > 0) {
+			Entry previousEntry = entries.get(listIndex - 1);
+			if(previousEntry.position + previousEntry.size > pos) {
+				throw new RuntimeException("Entry collision: " + entry + " and " + previousEntry);
+			}
+		}
+		if(listIndex < entries.size() - 1) {
+			Entry nextEntry = entries.get(listIndex + 1);
+			if(nextEntry.position <= pos + bytes) {
+				throw new RuntimeException("Entry collision: " + entry + " and " + nextEntry);
+			}
+		}
+		
+		vertexData.buffer.flip();
+		
+		glBindBuffer(GL_ARRAY_BUFFER, vbo);
+		glBufferSubData(GL_ARRAY_BUFFER, pos, vertexData.buffer);
+		glBindBuffer(GL_ARRAY_BUFFER, 0);
+		
+		entries.add(listIndex, entry);
+		
+		return entry;
+	}
+	
+	private void expandVBO() {
+		final long prevCapacity = this.capacity;
+		long newCapacity = this.capacity * 2L;
+		if(newCapacity < capacity) {
+			// future proof
+			throw new RuntimeException();
+		}
+		
+		System.out.println("Expand VBO Buffer: " + newCapacity);
+		
+		OpenGLHelper.checkError("pre expand buffer");
+		
+		int newBuffer = glGenBuffers();
+		glBindBuffer(GL_ARRAY_BUFFER, newBuffer);
+		glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_STATIC_DRAW);
+		
+		OpenGLHelper.checkError("create expand buffer");
+		
+		if(OpenGLHelper.gl31) {
+			glBindBuffer(GL31.GL_COPY_READ_BUFFER, this.vbo);
+			glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, newBuffer);
+			
+			GL31.glCopyBufferSubData(GL31.GL_COPY_READ_BUFFER, GL31.GL_COPY_WRITE_BUFFER, 0, 0, this.capacity);
+			
+			glBindBuffer(GL31.GL_COPY_READ_BUFFER, 0);
+			glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, 0);	
+		}else {
+			// confirmed to work on trash hardware
+			
+			int iPrevCapacity = (int) prevCapacity;
+			int iNewCapacity = (int) newCapacity;
+
+			if(iPrevCapacity < 0) throw new RuntimeException("Previous capacity < 0");
+			if(iNewCapacity < 0) throw new RuntimeException("New capacity < 0");
+			if(iNewCapacity < iPrevCapacity) throw new RuntimeException("New capacity < previous capacity: " + iNewCapacity + " < " + iPrevCapacity);
+			
+			ByteBuffer oldData = ByteBuffer.allocateDirect(iPrevCapacity).order(ByteOrder.nativeOrder());
+			
+			glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
+			glGetBufferSubData(GL_ARRAY_BUFFER, 0L, oldData);
+			
+			oldData.position(0);
+			
+			glBindBuffer(GL_ARRAY_BUFFER, newBuffer);
+			glBufferSubData(GL_ARRAY_BUFFER, 0L, oldData);
+		}
+		
+		OpenGLHelper.checkError("copy buffer");
+		
+		this.capacity = newCapacity;
+		this.vbo = newBuffer;
+	}
+	
+	public boolean removeEntry(Entry entry) {
+		return entries.remove(entry);
+	}
+	
+	public int getVbo() {
+		return vbo;
+	}
+	
+	public int entryCount() {
+		return entries.size();
+	}
+	
+	/**
+	 * A reference to some vertex data that has been stored in this buffer
+	 */
+	public class Entry {
+		
+		public final int position;
+		public final int size;
+		
+		private final int hashCode = entryHashCounter++;
+		
+		public Entry(int position, int size) {
+			this.position = position;
+			this.size = size;
+		}
+		
+		@Override
+		public String toString() {
+			return "VertexBufferEntry[position: " + position + ", size: " + size + "]";
+		}
+		
+		@Override
+		public int hashCode() {
+			return hashCode;
+		}
+		
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java b/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
new file mode 100644
index 000000000..71a5668a5
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
@@ -0,0 +1,244 @@
+package net.minecraft.client.render.terrain;
+
+import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL13.*;
+import static org.lwjgl.opengl.GL20.*;
+
+import java.nio.ByteBuffer;
+import java.util.ArrayList;
+import java.util.List;
+
+import com.b100.json.element.JsonObject;
+
+public class VertexConfig {
+	
+	public int drawMode;
+	public boolean enableColor = false;
+	public boolean enableTexture = false;
+	public boolean enableNormal = false;
+	public boolean enableLightmap = false;
+	public final List<VertexAttribute> attributes = new ArrayList<>();
+	
+	public void enableDirect(ByteBuffer buffer) {
+		int vertexSize = getVertexSize();
+		int offset = 0;
+		
+		buffer.position(offset);
+		glEnableClientState(GL_VERTEX_ARRAY);
+		glVertexPointer(3, GL_FLOAT, vertexSize, buffer);
+		offset += 12;
+		
+		if(enableColor) {
+			buffer.position(offset);
+			glColorPointer(4, GL_UNSIGNED_BYTE, vertexSize, buffer);
+			glEnableClientState(GL_COLOR_ARRAY);
+			offset += 4;
+		}else {
+			glDisableClientState(GL_COLOR_ARRAY);
+		}
+		
+		if(enableTexture) {
+			buffer.position(offset);
+			glTexCoordPointer(2, GL_FLOAT, vertexSize, buffer);
+			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
+			offset += 8;
+		}else {
+			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
+		}
+		
+		if(enableNormal) {
+			buffer.position(offset);
+			glNormalPointer(GL_BYTE, vertexSize, buffer);
+			glEnableClientState(GL_NORMAL_ARRAY);
+			offset += 3;
+		}else {
+			glDisableClientState(GL_NORMAL_ARRAY);
+		}
+		
+		glClientActiveTexture(GL_TEXTURE1);
+		if(enableLightmap) {
+			buffer.position(offset);
+			glTexCoordPointer(2, GL_SHORT, vertexSize, buffer);
+			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
+			offset += 4;
+		}else {
+			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
+		}
+		glClientActiveTexture(GL_TEXTURE0);
+		
+		for(int i=0; i < attributes.size(); i++) {
+			VertexAttribute attrib = attributes.get(i);
+			
+			buffer.position(offset);
+			glEnableVertexAttribArray(attrib.id);
+			glVertexAttribPointer(attrib.id, attrib.getSize(), attrib.type, false, vertexSize, buffer);
+			offset += attrib.getTypeSize();
+		}
+	}
+	
+	public void enableVBO(int vbo) {
+		glBindBuffer(GL_ARRAY_BUFFER, vbo);
+		
+		int vertexSize = getVertexSize();
+		int offset = 0;
+		
+		glEnableClientState(GL_VERTEX_ARRAY);
+		glVertexPointer(3, GL_FLOAT, vertexSize, offset);
+		offset += 12;
+		
+		if(enableColor) {
+			glColorPointer(4, GL_UNSIGNED_BYTE, vertexSize, offset);
+			glEnableClientState(GL_COLOR_ARRAY);
+			offset += 4;
+		}else {
+			glDisableClientState(GL_COLOR_ARRAY);
+		}
+		
+		if(enableTexture) {
+			glTexCoordPointer(2, GL_FLOAT, vertexSize, offset);
+			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
+			offset += 8;
+		}else {
+			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
+		}
+		
+		if(enableNormal) {
+			glNormalPointer(GL_BYTE, vertexSize, offset);
+			glEnableClientState(GL_NORMAL_ARRAY);
+			offset += 3;
+		}else {
+			glDisableClientState(GL_NORMAL_ARRAY);
+		}
+		
+		if(enableLightmap) {
+			glClientActiveTexture(GL_TEXTURE1);
+			glTexCoordPointer(2, GL_SHORT, vertexSize, offset);
+			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
+			offset += 4;
+			glClientActiveTexture(GL_TEXTURE0);
+		}
+		
+		for(int i=0; i < attributes.size(); i++) {
+			VertexAttribute attrib = attributes.get(i);
+			
+			glEnableVertexAttribArray(attrib.id);
+			glVertexAttribPointer(attrib.id, attrib.getSize(), attrib.type, false, vertexSize, offset);
+			offset += attrib.getTypeSize();
+		}
+	}
+	
+	public void disable() {
+		if(enableLightmap) {
+			glClientActiveTexture(GL_TEXTURE1);
+			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
+			glClientActiveTexture(GL_TEXTURE0);
+		}
+		
+		glBindBuffer(GL_ARRAY_BUFFER, 0);
+		for(int i=0; i < attributes.size(); i++) {
+			VertexAttribute attrib = attributes.get(i);
+			glDisableVertexAttribArray(attrib.id);
+		}
+	}
+	
+	public int getVertexSize() {
+		int size = 12;
+		
+		if(enableColor) size += 4;
+		if(enableTexture) size += 8;
+		if(enableNormal) size += 3;
+		if(enableLightmap) size += 4;
+		
+		for(int i=0; i < attributes.size(); i++) {
+			size += attributes.get(i).getTypeSize();
+		}
+		
+		return size;
+	}
+	
+	public VertexConfig copy() {
+		VertexConfig copy = new VertexConfig();
+		copy.drawMode = drawMode;
+		copy.enableColor = enableColor;
+		copy.enableTexture = enableTexture;
+		copy.enableNormal = enableNormal;
+		copy.enableLightmap = enableLightmap;
+		copy.attributes.addAll(attributes);
+		return copy;
+	}
+	
+	@Override
+	public boolean equals(Object obj) {
+		if(obj instanceof VertexConfig) {
+			return compare(this, (VertexConfig) obj) == 0;
+		}
+		return false;
+	}
+	
+	/**
+	 * Only used for debugging
+	 */
+	public JsonObject toJson() {
+		JsonObject object = new JsonObject();
+		object.set("drawMode", drawMode);
+		object.set("enableColor", enableColor);
+		object.set("enableTexcoord", enableTexture);
+		object.set("enableNormal", enableNormal);
+		object.set("enableLightmap", enableLightmap);
+		if(attributes.size() > 0) {
+			JsonObject attribsJson = new JsonObject();
+			
+			attribsJson.set("size", attributes.size());
+			
+			for(int i=0; i < attributes.size(); i++) {
+				VertexAttribute attribute = attributes.get(i);
+				JsonObject attribObject = new JsonObject();
+				
+				attribObject.set("id", attribute.id);
+				attribObject.set("type", attribute.type);
+				
+				attribsJson.set(attribute.name, attribObject);
+			}
+			
+			object.set("attribs", attribsJson);
+		}
+		return object;
+	}
+	
+	public static int compare(VertexConfig c1, VertexConfig c2) {
+		if(c1.drawMode != c2.drawMode) return 1;
+		if(c1.enableColor != c2.enableColor) return 2;
+		if(c1.enableTexture != c2.enableTexture) return 3;
+		if(c1.enableNormal != c2.enableNormal) return 4;
+		if(c1.enableLightmap != c2.enableLightmap) return 4;
+		
+		if(c1.attributes.size() != c2.attributes.size()) {
+			return 5;
+		}
+		
+		for(int i=0; i < c1.attributes.size(); i++) {
+			VertexAttribute attrib1 = c1.attributes.get(i);
+			VertexAttribute attrib2 = c2.attributes.get(i);
+			int compare = VertexAttribute.compare(attrib1, attrib2); 
+			if(compare != 0) {
+				return (6 + i) * 1000 + compare;
+			}
+		}
+		
+		return 0;
+	}
+	
+	public static void compareThrow(VertexConfig config1, VertexConfig config2) {
+		int compare = compare(config1, config2);
+		if(compare != 0) {
+			System.err.println("VertexConfig Mismatch:\n" + config1 + "\n!=\n" + config2);
+			throw new RuntimeException("VertexConfig mismatch " + compare + "!");
+		}	
+	}
+	
+	@Override
+	public String toString() {
+		return toJson().toString();
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/VertexData.java b/src/main/java/net/minecraft/client/render/terrain/VertexData.java
new file mode 100644
index 000000000..124c03505
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/VertexData.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.render.terrain;
+
+import static org.lwjgl.opengl.GL11.*;
+
+import java.nio.ByteBuffer;
+
+import net.minecraft.core.util.helper.Buffer;
+
+public class VertexData {
+	
+	public ByteBuffer buffer;
+	
+	public VertexConfig config = new VertexConfig();
+	
+	public int vertexCount;
+	
+	public VertexData(int size) {
+		buffer = Buffer.createBuffer(size);
+	}
+	
+	public void drawAll() {
+		draw(0, vertexCount);
+	}
+	
+	public void draw(int first, int count) {
+		if(count == 0) {
+			return;
+		}
+		
+		buffer.limit(config.getVertexSize() * vertexCount);
+		config.enableDirect(buffer);
+		glDrawArrays(config.drawMode, first, count);
+		config.disable();
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
index 1110cca62..79b4fe822 100644
--- a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
+++ b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
@@ -1,27 +1,16 @@
 package net.minecraft.client.render.tessellator;
 
-import static org.lwjgl.opengl.GL11.*;
-import static org.lwjgl.opengl.GL13.*;
-
 import java.nio.ByteBuffer;
 import java.nio.ByteOrder;
 
+import net.minecraft.client.render.terrain.VertexConfig;
+import net.minecraft.client.render.terrain.VertexData;
 import net.minecraft.core.util.helper.MathHelper;
-import org.lwjgl.opengl.GL11;
 
 public class TessellatorStandard extends TessellatorBase {
 
-	private int drawMode;
-	private boolean drawing;
-	
-	private ByteBuffer buffer;
-	
-	private boolean hasColor;
-	private boolean hasTexture;
-	private boolean hasLightmap;
-	private boolean hasNormal;
-	
-	private int vertexCount = 0;
+	public VertexData data;
+	public boolean drawing;
 	
 	private int color;
 	
@@ -41,7 +30,7 @@ public class TessellatorStandard extends TessellatorBase {
 	private boolean lockedColor = false;
 	
 	public TessellatorStandard(int bufferSize) {
-		this.buffer = ByteBuffer.allocateDirect(bufferSize).order(ByteOrder.nativeOrder());
+		data = new VertexData(bufferSize);
 	}
 	
 	@Override
@@ -50,18 +39,20 @@ public class TessellatorStandard extends TessellatorBase {
 			throw new IllegalStateException("Already drawing!");
 		}
 		
-		this.drawMode = drawMode;
+		VertexConfig config = data.config;
+		
+		config.drawMode = drawMode;
 		this.drawing = true;
-		this.vertexCount = 0;
+		data.vertexCount = 0;
 		
-		this.hasColor = false;
-		this.hasTexture = false;
-		this.hasLightmap = false;
-		this.hasNormal = false;
+		config.enableColor = false;
+		config.enableTexture = false;
+		config.enableLightmap = false;
+		config.enableNormal = false;
 
 		this.lockedColor = false;
 		
-		this.buffer.clear();
+		data.buffer.clear();
 	}
 
 	@Override
@@ -69,115 +60,68 @@ public class TessellatorStandard extends TessellatorBase {
 		checkIsDrawing();
 		this.drawing = false;
 		
-		if(vertexCount == 0) {
+		if(data.vertexCount == 0) {
 			return;
 		}
 		
-		int vertexSize = getVertexSize();
-		int offset = 0;
-		
-		buffer.flip();
-		
-		glEnableClientState(GL_VERTEX_ARRAY);
-		buffer.position(0);
-		glVertexPointer(3, GL_FLOAT, vertexSize, buffer);
-		offset += 12;
-
-		if(hasColor) {
-			glEnableClientState(GL_COLOR_ARRAY);
-			buffer.position(offset);
-			glColorPointer(4, GL_UNSIGNED_BYTE, vertexSize, buffer);
-			offset += 4;
-		}else {
-			glDisableClientState(GL_COLOR_ARRAY);
-		}
-		if(hasTexture) {
-			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
-			buffer.position(offset);
-			glTexCoordPointer(2, GL_FLOAT, vertexSize, buffer);
-			offset += 8;
-		}else {
-			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
-		}
-		if(hasLightmap) {
-			glClientActiveTexture(GL_TEXTURE1);
-			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
-			buffer.position(offset);
-			glTexCoordPointer(2, GL_SHORT, vertexSize, buffer);
-			glClientActiveTexture(GL_TEXTURE0);
-			offset += 4;
-		}else {
-			glClientActiveTexture(GL_TEXTURE1);
-			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
-			glClientActiveTexture(GL_TEXTURE0);
-		}
-		if(hasNormal) {
-			glEnableClientState(GL_NORMAL_ARRAY);
-			buffer.position(offset);
-			glNormalPointer(GL_BYTE, vertexSize, buffer);
-			offset += 3;
-		}else {
-			glDisableClientState(GL_NORMAL_ARRAY);
-		}
-		
-		glDrawArrays(drawMode, 0, vertexCount);
+		data.buffer.flip();
+		data.drawAll();
 	}
 	
 	public int getVertexSize() {
-		int vertexSize = 12;
-		if(hasColor) vertexSize += 4;
-		if(hasTexture) vertexSize += 8;
-		if(hasLightmap) vertexSize += 4;
-		if(hasNormal) vertexSize += 3;
-		return vertexSize;
+		return data.config.getVertexSize();
 	}
 
 	@Override
 	public void addVertex(double x, double y, double z) {
 		checkIsDrawing();
 
-		if(buffer.capacity() < buffer.position() + 64) {
-			int newSize = buffer.capacity() * 2;
+		if(data.buffer.capacity() < data.buffer.position() + 64) {
+			int newSize = data.buffer.capacity() * 2;
 			
-			System.out.println("Expanding Tessellator Buffer (" + buffer.capacity() + " -> " + newSize + ")");
+			System.out.println("Expanding Tessellator Buffer (" + data.buffer.capacity() + " -> " + newSize + ")");
 			
 			ByteBuffer newBuffer = ByteBuffer.allocateDirect(newSize).order(ByteOrder.nativeOrder());
-			this.buffer.flip();
-			newBuffer.put(buffer);
-			this.buffer = newBuffer;
+			data.buffer.flip();
+			newBuffer.put(data.buffer);
+			data.buffer = newBuffer;
 		}
 		
+		ByteBuffer buffer = data.buffer;
+		
 		buffer.putFloat((float) (offsetX + x));
 		buffer.putFloat((float) (offsetY + y));
 		buffer.putFloat((float) (offsetZ + z));
 
-		if(hasColor) {
+		VertexConfig config = data.config;
+		
+		if(config.enableColor) {
 			buffer.putInt(color);
 		}
-		if(hasTexture) {
+		if(config.enableTexture) {
 			buffer.putFloat((float) textureU);
 			buffer.putFloat((float) textureV);
 		}
-		if(hasLightmap) {
+		if(config.enableLightmap) {
 			buffer.putInt(lightmapCoord);
 		}
-		if(hasNormal) {
+		if(config.enableNormal) {
 			buffer.put(normalX);
 			buffer.put(normalY);
 			buffer.put(normalZ);
 		}
 		
-		this.vertexCount++;
+		data.vertexCount++;
 	}
 
 	@Override
 	public void setTextureUV(double u, double v) {
 		checkIsDrawing();
-		if(!hasTexture) {
-			if(vertexCount > 0) {
+		if(!data.config.enableTexture) {
+			if(data.vertexCount > 0) {
 				throw new IllegalStateException("Texture is disabled!");
 			}
-			this.hasTexture = true;
+			data.config.enableTexture = true;
 		}
 		
 		this.textureU = u;
@@ -187,11 +131,11 @@ public class TessellatorStandard extends TessellatorBase {
 	@Override
 	public void setLightmapCoord(int lightmapCoord) {
 		checkIsDrawing();
-		if(!hasLightmap) {
-			if(vertexCount > 0) {
+		if(!data.config.enableLightmap) {
+			if(data.vertexCount > 0) {
 				throw new IllegalStateException("Lightmap is disabled!");
 			}
-			this.hasLightmap = true;
+			data.config.enableLightmap = true;
 		}
 		
 		this.lightmapCoord = lightmapCoord;
@@ -203,11 +147,11 @@ public class TessellatorStandard extends TessellatorBase {
 		if(lockedColor) {
 			return;
 		}
-		if(!hasColor) {
-			if(vertexCount > 0) {
+		if(!data.config.enableColor) {
+			if(data.vertexCount > 0) {
 				throw new IllegalStateException("Color is disabled!");
 			}
-			this.hasColor = true;
+			data.config.enableColor = true;
 		}
 		
 		r = MathHelper.clamp(r, 0, 255);
@@ -221,11 +165,11 @@ public class TessellatorStandard extends TessellatorBase {
 	@Override
 	public void setNormal(float x, float y, float z) {
 		checkIsDrawing();
-		if(!hasNormal) {
-			if(vertexCount > 0) {
+		if(!data.config.enableNormal) {
+			if(data.vertexCount > 0) {
 				throw new IllegalStateException("Texture is disabled!");
 			}
-			this.hasNormal = true;
+			data.config.enableNormal = true;
 		}
 		
 		this.normalX = (byte) (x * 127.0f);
diff --git a/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index 46eb62b1a..384e4e205 100644
--- a/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -200,7 +200,15 @@ public class GameWindowGLFW implements GameWindow {
 
 	@Override
 	public int getFrequency() {
-		return glfwGetVideoMode(window).refreshRate();
+		GLFWVidMode vidMode = glfwGetVideoMode(window);
+		if (vidMode != null) {
+			return vidMode.refreshRate();
+		} else {
+			int x = windowPosX + windowWidth / 2;
+			int y = windowPosY + windowHeight / 2;
+			MonitorInfo monitor = getMonitorAt(x, y);
+			return monitor.refreshRate;
+		}
 	}
 	
 	@Override
@@ -251,7 +259,7 @@ public class GameWindowGLFW implements GameWindow {
 		}
 	}
 	
-	class MonitorInfo {
+	public static class MonitorInfo {
 		
 		public final long handle;
 		public final int posX;
